/*
 * AndFlmsg.java  
 *   
 * Copyright (C) 2014 John Douyere (VK2ETA)  
 *   
 * This program is distributed in the hope that it will be useful,  
 * but WITHOUT ANY WARRANTY; without even the implied warranty of  
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the  
 * GNU General Public License for more details.  
 *   
 * You should have received a copy of the GNU General Public License  
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.  
 */

package com.AndFlmsg; 

/**
 *
 * @author John Douyere <vk2eta@gmail.com>
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Locale;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import android.widget.AdapterView.OnItemSelectedListener;
import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.bluetooth.BluetoothAdapter;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.OnSharedPreferenceChangeListener;
import android.database.Cursor;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.location.GpsStatus;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.media.AudioManager;
import android.net.Uri;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.preference.PreferenceManager;
import android.provider.ContactsContract.CommonDataKinds.Email;
import android.telephony.PhoneStateListener;
import android.telephony.TelephonyManager;
import android.text.format.Time;
import android.util.Log;
import android.view.Display;
import android.view.GestureDetector;
import android.view.GestureDetector.SimpleOnGestureListener;
import android.view.Gravity;
import android.view.KeyEvent;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.view.Window;
import android.view.WindowManager;
import android.view.animation.AlphaAnimation;
import android.view.animation.Animation;
import android.view.animation.AnimationSet;
import android.view.animation.LayoutAnimationController;
import android.view.animation.TranslateAnimation;
import android.view.inputmethod.InputMethodManager;
import android.webkit.WebChromeClient;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.LinearLayout.LayoutParams;
import android.widget.ListView;
import android.widget.PopupWindow;
import android.widget.PopupWindow.OnDismissListener;
import android.widget.ProgressBar;
import android.widget.ScrollView;
import android.widget.Spinner;
import android.widget.TextView;
import android.widget.Toast;


@SuppressLint("SetJavaScriptEnabled")
public class AndFlmsg extends Activity {

	public static Context myContext;

	public static Window myWindow = null;

	public static boolean RXParamsChanged = false;

	public static SharedPreferences mysp = null;

	// Last screen used (Messages, Terminal, Modem, etc...)
	private int lastMsgScreen = INBOXVIEW; //default to start with
	//	private static ArrayList<email> emaillist;
	private static LayoutInflater inflater = null;
	private static PopupWindow pw;
	//Are we in a popup display?
	private static boolean inPopup = false;
	private static String welcomeString = "\n Welcome to AndFlmsg " + Processor.version + "\n\n This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.\n\n Swipe across the screen to navigate to the other screens and use the device Menu button to get access to the preferences and additional functions.\n\n Visit www.w1hkj.com for more details\n\n 73, The Fldigi Team \n\n";
	private static boolean hasDisplayedWelcome = false;

	//Horizontal Fling detection despite scrollview
	private GestureDetector mGesture;
	//screen transitions / animations
	private static final int NORMAL = 0;
	private static final int LEFT = 1;
	private static final int RIGHT = 2;
	private static final int TOP = 3;
	private static final int BOTTOM = 4;

	// Views values
	private final static int TERMVIEW = 1;
	private final static int MODEMVIEWnoWF = 3;
	private final static int MODEMVIEWwithWF = 4;
	private final static int INBOXVIEW = 5;
	private final static int DRAFTSVIEW = 6;
	private final static int OUTBOXVIEW = 7;
	private final static int FORMSVIEW = 8;
	private final static int TEMPLATESVIEW = 9;
	private final static int SENTITEMSVIEW = 10;
	private final static int LOGSVIEW = 20;
	private final static int ABOUTVIEW = 20;

	static ProgressBar SignalQuality = null;
	static ProgressBar CpuLoad = null;

	static int currentview = 0;

	//Toast text display (declared here to allow for quick replacement rather than queuing)
	static private Toast myToast;

	//Forms display and forward
	private static String mDisplayForm = new String();
	private static String mFileName = new String();
	public static String mHeader = new String();

	
	// Layout Views
	private static TextView myTermTV;
	private static ScrollView myTermSC;
	private static TextView myModemTV;
	private static ScrollView myModemSC;
	private static waterfallView myWFView;

	private ListView msgListView;
	private WebView mWebView;
	// Generic button variable. Just for callback initialisation
	private Button myButton;
	private CheckBox checkbox = null; 
	private static int paramCount = 0;
	private static String arlMsg = "";
	private static AlertDialog myAlertDialog = null;
	private static String formattedMsg = "";
	private static String msgFieldToUpdate = "";
	private static String checkField;
	private static String checkFieldToUpdate;
		
	
	public static LocationManager locationManager;
	public GPSListener locationListener = new GPSListener();
	public static boolean GPSisON = false;
	public static boolean GPSTimeAcquired = false;
	public static int DeviceToGPSTimeCorrection = 0;

	public static String TerminalBuffer = "";
	public static String ModemBuffer = "";

	// Member object for processing of Rx and Tx
	// Can be stopped (i.e no RX) to save battery and allow Android to reclaim
	// resources if not visible to the user
	public static boolean ProcessorON = false;
	private static boolean modemPaused = false;
	
	//For managing the "Send All Messages" process
	private static boolean SendingAllMessages = false;
	private static String txMessageCount = "";

	//Tx Buffer
	private static String bufferToTx;
	
	//Notifications
	private NotificationManager myNotificationManager;
	private Notification myNotification;	

	// Array adapter for the messages' list
	public static ArrayAdapter<String> msgArrayAdapter;

	// Need handler for callbacks to the UI thread
	public static final Handler mHandler = new Handler();
	public static Thread displayMessagesThread = null;
	public static Runnable displayMessagesRunnable = null; 
	
	//Contact email picker
	private static final int CONTACT_PICKER_RESULT = 10101;
	//Contact email picker
	private static final int SHARE_MESSAGE_RESULT = 10202;

	// Bluetooth handfree / headset
	public static boolean scoChannelOn = false;
	public static boolean toBluetooth = false;
	public static AudioManager mAudioManager;
	public static BluetoothAdapter mBluetoothAdapter = null;
	//To monitor the incoming calls and disconnect Bluetooth so that we don't send the phone call audio to the radio
	private TelephonyManager tmgr = null;
	/* Parked code for later
	//  Broadcast receiver for Bluetooth  broadcasts 
	//	private final BroadcastReceiver myBroadcastReceiver = new mBroadcastReceiver();

	// Need to start an audio channel with the Bluetooth headset/handsfree
	// Either use startVoiceRecognition() (V3.0 onwards)
	// OR
	// StartBluetoothSCO() (V2.2 Onwards)
	 * BluetoothHeadset mBluetoothHeadset;
	 * 
	 * private BluetoothHeadset.ServiceListener mBluetoothHeadsetServiceListener
	 * = new BluetoothHeadset.ServiceListener() { public void
	 * onServiceConnected() { if (mBluetoothHeadset != null &&
	 * mBluetoothHeadset.getState() == BluetoothHeadset.STATE_CONNECTED) { //
	 * Log.e(TAG, "######### STARTING VOICE RECOGNITION ############");
	 * mBluetoothHeadset.startVoiceRecognition();
	 * mAudioManager.setMode(AudioManager.MODE_IN_CALL); } } public void
	 * onServiceDisconnected() { int aaa = 0; }
	 * 
	 * };
	 */


	// Listener for changes in preferences
	public static OnSharedPreferenceChangeListener splistener;


	// Create runnable for updating the waterfall display
	public static final Runnable updatewaterfall = new Runnable() {
		public void run() {
			if (myWFView != null) {
				//myWFView.invalidate();
				myWFView.postInvalidate();
			}
		}
	};

	

	// Create runnable for changing the main window's title
	public static final Runnable updatetitle = new Runnable() {
		public void run() {
			if (myWindow != null) {
				if (ProcessorON) {
					if (Processor.TXActive) {
						myWindow.setTitleColor(Color.YELLOW);
					} else {
						myWindow.setTitleColor(Color.CYAN);
					}
					int mIndex = Modem.getModeIndexFullList(Processor.RxModem);
					myWindow.setTitle("AndFlmsg-" + Processor.Status + AndFlmsg.txMessageCount + " - "
							+ Modem.modemCapListString[mIndex]);
				} else {
					myWindow.setTitleColor(Color.WHITE);
					myWindow.setTitle("AndFlmsg - Modem OFF");
				}
			}
		}
	};



	// Runnable for updating the signal quality bar in Modem Window
	public static final Runnable updatesignalquality = new Runnable() {
		public void run() {
			if ((SignalQuality != null)
					&& ((currentview == MODEMVIEWnoWF) || (currentview == MODEMVIEWwithWF))) {
				SignalQuality.setProgress((int) Modem.metric);
				SignalQuality.setSecondaryProgress((int) Modem.squelch);
			}
		}
	};

	// Runnable for updating the CPU load bar in Modem Window
	public static final Runnable updatecpuload = new Runnable() {
		public void run() {
			if ((CpuLoad != null)
					&& ((currentview == MODEMVIEWnoWF) || (currentview == MODEMVIEWwithWF))) {
				CpuLoad.setProgress((int) Processor.cpuload);
			}
		}
	};


	// Create runnable for posting to terminal window
	public static final Runnable addtoterminal = new Runnable() {
		public void run() {
			// myTV.setText(Processor.TermWindow);
			if (myTermTV != null) {
				myTermTV.append(Processor.TermWindow);
				TerminalBuffer += Processor.TermWindow;
				if (TerminalBuffer.length() > 60000)
					TerminalBuffer = TerminalBuffer.substring(5000);
				Processor.TermWindow = "";
				// Then scroll to the bottom
				if (myTermSC != null) {
					myTermSC.post(new Runnable() {
						public void run() {
							myTermSC.fullScroll(View.FOCUS_DOWN);
						}
					});
				}
			}
		}
	};

	// Create runnable for posting to modem window
	public static final Runnable addtomodem = new Runnable() {
		public void run() {
			// myTV.setText(Processor.TermWindow);
			if (myModemTV != null) {
				myModemTV.append(Processor.monitor);
				ModemBuffer += Processor.monitor;
				if (ModemBuffer.length() > 60000)
					ModemBuffer = ModemBuffer.substring(5000);
				Processor.monitor = "";
				// Then scroll to the bottom
				if (myModemSC != null) {
					myModemSC.post(new Runnable() {
						public void run() {
							myModemSC.fullScroll(View.FOCUS_DOWN);
							//myModemSC.smoothScrollBy(20,0);
						}
					});
				}
			}
		}
	};




	//Phone state listener to disable Bluetooth when receiving a call
	//This is to prevent the phone call's audio to be sent to the radio,
	// as well as stopping the TXing from this app until the phone call is finished
	//This action is only active when we have enabled Bluetooth in the application
	private PhoneStateListener mPhoneStateListener = new PhoneStateListener() {
		@Override
		public void onCallStateChanged(int state, String incomingNumber) {
			if (state == TelephonyManager.CALL_STATE_RINGING) {
				//Log.v(TAG, " CALL_STATE_RINGING");
				//If using the bluetooth interface for the digital link, 
				//  disable it otherwise the phone call will use it.
				if (AndFlmsg.toBluetooth) {
					AndFlmsg.toBluetooth = false;
					AndFlmsg.mAudioManager.setMode(AudioManager.MODE_NORMAL);
					if (Double.valueOf(android.os.Build.VERSION.SDK) > 8) { //Froyo bug
						AndFlmsg.mAudioManager.stopBluetoothSco();
						if (AndFlmsg.mBluetoothAdapter != null) {
							if (AndFlmsg.mBluetoothAdapter.isEnabled()) {
								AndFlmsg.mBluetoothAdapter.disable(); 
							} 
						}
					}
					AndFlmsg.mAudioManager.setBluetoothScoOn(false);
				}

			} else if (state == TelephonyManager.CALL_STATE_IDLE) {
				//Log.v(TAG, " CALL_STATE_IDLE");
			}
		}
	};

	

	//Update the Outbox list view IF we are on that view AND NOT in a popup
	class DisplayMessagesRunner implements Runnable{
		// @Override
		public void run() {
			runOnUiThread(new Runnable() {
				public void run() {
					if (currentview == OUTBOXVIEW && !inPopup) {
						displayMessages(BOTTOM,currentview);
					}
				}
			});
		}
	}

/*		
	//Update the Outbox list view IF we are on that view AND NOT in a popup
	public void runDisplayMessages() {
		runOnUiThread(new Runnable() {
			public void run() {
				if (currentview == OUTBOXVIEW && !inPopup) {
					displayMessages(BOTTOM,currentview);
				}
			}
		});
	}
*/	

	public void DisplayTime() {
		runOnUiThread(new Runnable() {
			public void run() {
				if (currentview == TERMVIEW) {
					try{
						TextView txtCurrentTime= (TextView)findViewById(R.id.minsec);
						long nowInMilli = System.currentTimeMillis();
						Time mytime = new Time();
						//Not using GPS time? Make sure the variables are reset
						if (!config.getPreferenceB("USEGPSTIME", false)) {
							DeviceToGPSTimeCorrection = 0;
							GPSTimeAcquired = false;
						}
						mytime.set(nowInMilli + (DeviceToGPSTimeCorrection * 1000) ); //now +/- GPS correction if any
						String MinutesStr = "00" + mytime.minute  ;
						MinutesStr = MinutesStr.substring(MinutesStr.length() - 2, MinutesStr.length());
						String SecondsStr = "00" + mytime.second  ;
						SecondsStr = SecondsStr.substring(SecondsStr.length() - 2, SecondsStr.length());
						txtCurrentTime.setText(MinutesStr + ":" + SecondsStr);
						if (GPSTimeAcquired) {
							txtCurrentTime.setTextColor(Color.GREEN);
						} else {
							txtCurrentTime.setTextColor(Color.YELLOW);
						}
					}catch (Exception e) {}
				}
			}
		});
	}



	class DisplayTimeRunner implements Runnable{
		// @Override
		public void run() {
			while(!Thread.currentThread().isInterrupted()){
				try {
					DisplayTime();
					Thread.sleep(1000);
				} catch (InterruptedException e) {
					Thread.currentThread().interrupt();
				}catch(Exception e){
				}
			}
		}
	}

	
	
	@Override
	public boolean dispatchTouchEvent(MotionEvent ev) {
		boolean handled = super.dispatchTouchEvent(ev);
		handled = mGesture.onTouchEvent(ev);
		return handled;
	}


	private SimpleOnGestureListener mOnGesture = new GestureDetector.SimpleOnGestureListener() {
		private float xDistance, yDistance, lastX, lastY;

		@Override
		public boolean onDown(MotionEvent e) {
			xDistance = yDistance = 0f;
			lastX = e.getX();
			lastY = e.getY();
			return false;
		}

		@Override
		public boolean onFling(MotionEvent e1, MotionEvent e2, float velocityX, float velocityY) {
			final float curX = e2.getX();
			final float curY = e2.getY();
			xDistance += (curX - lastX);
			yDistance += (curY - lastY);
			lastX = curX;
			lastY = curY;
			if(Math.abs(xDistance) > Math.abs(yDistance) && Math.abs(velocityX) > 2000) {
				//toastText("fling......");
				NavigateScreens((int) xDistance);
				return false;
			}
			return true;
		}

		@Override
		public boolean onScroll(MotionEvent e1, MotionEvent e2, float distanceX, float distanceY) {
			return false;
		}
	};    


	//Swipe (fling) handling to move from screen to screen
	private void NavigateScreens(int FlingDirection){

		//Navigate between screens by gesture (on top of menu button acces)

		if (FlingDirection > 0) { //swipe/fling right

			switch (currentview) {

			case TERMVIEW : displayMessages(RIGHT, lastMsgScreen);
				break; 

			case  MODEMVIEWnoWF :
			case  MODEMVIEWwithWF : displayTerminal(RIGHT);
			break; 

			case INBOXVIEW : 
			case DRAFTSVIEW :
			case OUTBOXVIEW :
			case FORMSVIEW :
			case TEMPLATESVIEW :
			case SENTITEMSVIEW :
				displayModem(RIGHT, false);
				break; 

//     			case NEWMSGVIEW :
				//do nothing
//				break;

			default: displayTerminal(RIGHT); //Just in case


			}
		} else { //swipe/fling left
			switch (currentview) {

			case TERMVIEW : displayModem(LEFT, false);
			break; 

			case  MODEMVIEWnoWF : 
			case  MODEMVIEWwithWF : 
				// displayAPRS(LEFT);
				displayMessages(LEFT, lastMsgScreen);
				break; 

			case INBOXVIEW : 
			case DRAFTSVIEW :
			case OUTBOXVIEW :
			case FORMSVIEW :
			case TEMPLATESVIEW :
			case SENTITEMSVIEW :
				displayTerminal(LEFT);
				break; 

//			case NEWMSGVIEW :
				//do nothing
//				break;

			default: displayTerminal(LEFT); //Just in case

			} 

		}

	}



	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// Call the folder handling method
		Processor.handlefolderstructure();

		//Get new gesture detector for flings over scrollviews
		mGesture = new GestureDetector(this, mOnGesture);

		//Initialize Toast for use in the Toast display routines below
		myToast = Toast.makeText(AndFlmsg.this, "",	Toast.LENGTH_SHORT);

		//Debug
		//middleToastText("ONCREATE CALLED");

		//Get a static copy of the base Context
		//JD Debug		//myContext = this.getBaseContext();
		myContext = AndFlmsg.this;
		//Initialize the notification manager
		myNotificationManager = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);

		// Bluetooth
		mAudioManager = (AudioManager) myContext
				.getSystemService(Context.AUDIO_SERVICE);
		mBluetoothAdapter = BluetoothAdapter.getDefaultAdapter();    

		// Register for phone state monitoring
		tmgr = (TelephonyManager)
				myContext.getSystemService(Context.TELEPHONY_SERVICE);
		tmgr.listen(mPhoneStateListener, PhoneStateListener.LISTEN_CALL_STATE);

		//Launch task for time display (Time is GPS time aligned if requested)
		Runnable displayTimeRunnable = new DisplayTimeRunner();
		Thread displayTimeThread = new Thread(displayTimeRunnable);
		displayTimeThread.start();

		//init NMEA listener for GPS time (to negate the device clock drift when not in mobile reception area)
		locationManager = (LocationManager) this
				.getSystemService(Context.LOCATION_SERVICE);
		locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
		locationManager.addNmeaListener(new GpsStatus.NmeaListener() {
			public void onNmeaReceived(long timestamp, String nmea) {
				if (config.getPreferenceB("USEGPSTIME", false)) {
					String[] NmeaArray = nmea.split(",");
					if (NmeaArray[0].equals("$GPGGA")){
						//debug
						//Processor.Terminalwindow += "\n NMEA is :"+nmea;
						//AndFlmsg.mHandler.post(AndFlmsg.addtoTerminal);
						if (NmeaArray[1].indexOf(".") > 4) {
							String GpsTime = NmeaArray[1].substring(0,NmeaArray[1].indexOf("."));
							GPSTimeAcquired = true; //Mark that we have acquired time (for the clock colour display and autobeacon time)
							GpsTime = "000000" + GpsTime;
							//							Processor.APRSwindow += " GpsTime:" + GpsTime + "\n";
							GpsTime = GpsTime.substring(GpsTime.length() - 4, GpsTime.length());
							int GpsMin = Integer.parseInt(GpsTime.substring(0,2));
							int GpsSec = Integer.parseInt(GpsTime.substring(2,4));
							//Apply leap seconds correction: GPS is 16 seconds faster than UTC as of June 2013.
							//Some devices do not apply this automatically (depends on the internal GPS engine)
							int leapseconds = Integer.parseInt(config.getPreferenceS("LEAPSECONDS", "0"));
							GpsSec -= leapseconds;
							if (GpsSec < 0) {
								GpsSec += 60;
								GpsMin --;
								if (GpsMin < 0) {
									GpsMin += 60;
								}
							}
							//In case of (unexpected) negative leap seconds values
							if (GpsSec > 60) {
								GpsSec -= 60;
								GpsMin ++;
								if (GpsMin > 60) {
									GpsMin -= 60;
								}
							}
							//Compare to current device time and date and calculate the offset to be applied at display
							long nowInMilli = System.currentTimeMillis();
							long timeTarget = nowInMilli;
							Time mytime = new Time();
							mytime.set(timeTarget); //initialized to now
							int DeviceTime = mytime.second + (mytime.minute * 60);
							DeviceToGPSTimeCorrection = (GpsSec + (GpsMin * 60)) - DeviceTime;
						}
					}
					//loggingclass.writelog("Timestamp is :" +timestamp+"   nmea is :"+nmea,
					//					  null, true);
				}
			}});


		// Init config
		mysp = PreferenceManager.getDefaultSharedPreferences(this);

		// Set default modes
		Processor.TxModem = config.getPreferenceI("LASTMODEUSED",101);
		Processor.RxModem = config.getPreferenceI("LASTMODEUSED",101);

		//Get the RSID flags from stored preferences
		Modem.rxRsidOn = config.getPreferenceB("RXRSID", false);
		Modem.txRsidOn = config.getPreferenceB("TXRSID", false);

		// We start with the terminal "screen"
		displayTerminal(NORMAL);
	}

	
	
	/** Called when the activity is (re)started (to foreground) **/
	@Override
	public void onStart() {
		super.onStart();
		// Store preference reference for later (config.java)
		mysp = PreferenceManager.getDefaultSharedPreferences(this);
		// Refresh defaults since we could be coming back
		// from the preference activity

		// Re-initilize modem when NOT busy to use the latest parameters
		if (!Processor.ReceivingForm   && RXParamsChanged) {
			// Reset flag then stop and restart modem
			RXParamsChanged = false;
			//Cycle modem service off then on
			if (ProcessorON) {
				if (Modem.modemState == Modem.RXMODEMRUNNING) {
					Modem.stopRxModem();	
					stopService(new Intent(AndFlmsg.this, Processor.class));
					ProcessorON = false;
					//Force garbage collection to prevent Out Of Memory errors on small RAM devices
					System.gc();
				}
			}
			//Wait for modem to stop and then restart
			while (Modem.modemState != Modem.RXMODEMIDLE) {
				try {
					Thread.sleep(250);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			//Force garbage collection to prevent Out Of Memory errors on small RAM devices
			System.gc();
			
			//Get current mode index (returns first position if not in list anymore in case we changed to custom mode list on the current mode)
			Processor.RxModem = Processor.TxModem = Modem.customModeListInt[Modem.getModeIndex(Processor.RxModem)];

			startService(new Intent(AndFlmsg.this,
					Processor.class));
			ProcessorON = true;

			//Finally, if we were on the modem screen AND we come back to it, then
			//   redisplay in case we changed the waterfall frequency
			if (currentview == MODEMVIEWwithWF) {
				displayModem(NORMAL, true);
			}
		} else { // start if not ON yet AND we haven't paused the modem manually
			if (!ProcessorON && !modemPaused) {
				//Force garbage collection to prevent Out Of Memory errors on small RAM devices
				System.gc();
				startService(new Intent(AndFlmsg.this, Processor.class));
				ProcessorON = true; 
				//Only for Android 3.0 and UP
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
					Intent notificationIntent = new Intent(this, AndFlmsg.class);
					notificationIntent.setFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);
					PendingIntent pIntent = PendingIntent.getActivity(this, 0, notificationIntent, 0);

					// build notification
					// the addAction re-use the same intent to keep the example short
					myNotification = new Notification(R.drawable.notificationicon, 
							"Modem ON", System.currentTimeMillis());

					myNotification.setLatestEventInfo(myContext, "Fdigi Modem ON", 
							"Microphone/Bluetooth in use by Modem", pIntent);

					myNotification.flags |= Notification.FLAG_NO_CLEAR;

					myNotificationManager.notify(9999, myNotification); 
				}
			}
		}
		AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
	}

	@Override
	public void onPause() {
		super.onPause();
	}

	@Override
	public void onResume() {
		super.onResume();
	}


	@Override
	public void onDestroy() {
		super.onDestroy();
	}


	// Option Menu
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.menu, menu);
		return true;
	}


	/* Parked code for monitoring the user-controlled enabling of the Bluetooth interface
	@Override
   public void onActivityResult(int requestCode, int resultCode, Intent data) {
        switch (requestCode) {
        case REQUEST_CONNECT_DEVICE:
            // When DeviceListActivity returns with a device to connect
            if (resultCode == Activity.RESULT_OK) {
                // Get the device MAC address
                String address = data.getExtras()
                                     .getString(DeviceListActivity.EXTRA_DEVICE_ADDRESS);
                // Get the BLuetoothDevice object
                BluetoothDevice device = mBluetoothAdapter.getRemoteDevice(address);
                // Attempt to connect to the device
                mChatService.connect(device);
            }
            break;

        case REQUEST_ENABLE_BT:
            // When the request to enable Bluetooth returns
            if (resultCode == Activity.RESULT_OK) {
                // Bluetooth is now enabled, so set up an audio channel
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8) {
					mAudioManager.startBluetoothSco();
				} 
				//Android 2.1. Needs testinband.apk to be launched before hand 
				mAudioManager.setMode(AudioManager.MODE_IN_CALL);
				mAudioManager.setBluetoothScoOn(true);
				// mAudioManager.setSpeakerphoneOn(false);
				toBluetooth = true;
            } else {
                // User did not enable Bluetooth or an error occured
				toBluetooth = false;
				Toast.makeText(this, "Bluetooth has not been enabled", Toast.LENGTH_LONG).show();
            }
        }
    }
	 */



	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		switch (requestCode) {
		case CONTACT_PICKER_RESULT:
			if (resultCode == RESULT_OK && data != null) {
				Cursor cursor = null;
				String email = "";
				try {
					Uri result = data.getData();
					// get the contact id from the Uri
					String id = result.getLastPathSegment();

					// query for everything email
					cursor = getContentResolver().query(Email.CONTENT_URI,
							null, Email.CONTACT_ID + "=?", new String[] { id },
							null);

					int emailIdx = cursor.getColumnIndex(Email.DATA);

					// let's just get the first email
					if (cursor.moveToFirst()) {
						email = cursor.getString(emailIdx);
					}
				} catch (Exception ex) {
					loggingclass.writelog("Failed to get email data" + ex.getMessage(),
							null, true);
				} finally {
					if (cursor != null) {
						cursor.close();
					}
					EditText emailEntry = (EditText) findViewById(R.id.emailaddress);
					if (emailEntry != null) emailEntry.setText(email);
					if (email.length() == 0) {
						Toast.makeText(this, "No email found for contact.",
								Toast.LENGTH_SHORT).show();
					}

				}
			}
			break;
		case SHARE_MESSAGE_RESULT:
			if (resultCode == RESULT_OK) {
				//Contrary to ALL OTHER apps, stupid Gmail does not return RESULT_OK if the 
				//  user presses the Send action in the email.
				//So we can't use this callback to automate the transfer to the sent folder!!!!
			}
			break;
		}
	}


	// Option Screen handler
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
		switch (item.getItemId()) {
		case R.id.prefs:
			Intent OptionsActivity = new Intent(AndFlmsg.this, myPreferences.class);
			startActivity(OptionsActivity);
			break;
		case R.id.About:
			displayAbout();
			break;
		case R.id.BTon:
			// mBluetoothHeadset.startVoiceRecognition();
			if (mBluetoothAdapter != null) {
				//Code that works (Manual connect to BT device)
				if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8) {
					mAudioManager.startBluetoothSco();
				}
				mAudioManager.setMode(AudioManager.MODE_IN_CALL);
				mAudioManager.setBluetoothScoOn(true);
				toBluetooth = true;
			}
			break;
		case R.id.BToff:
			toBluetooth = false;
			mAudioManager.setMode(AudioManager.MODE_NORMAL);
			mAudioManager.setBluetoothScoOn(false);
			if (Double.valueOf(android.os.Build.VERSION.SDK) >= 8) {
				mAudioManager.stopBluetoothSco();
			}
			break;
		case R.id.exit:
			myAlertDialog.setMessage("Are you sure you want to Exit?");
			myAlertDialog.setCancelable(false);
			myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					//					Toast.makeText(this, "GoodBye", Toast.LENGTH_SHORT).show();
					// Stop the Modem and Listening Service
					if (ProcessorON) {
						stopService(new Intent(AndFlmsg.this, Processor.class));
						ProcessorON = false;
						//Only for Android 3.0 and UP
						if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
							//Remove the notification
							myNotificationManager.cancel(9999);
							ProcessorON = false;
						}
					}
					// Stop the GPS if running
					if (locationManager != null) {
						locationManager.removeUpdates(locationListener);
					}
					//Close that activity and return to previous screen
					finish();
					//Kill the process
					android.os.Process.killProcess(android.os.Process.myPid());
				}	
			});
			myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int id) {
					dialog.cancel();
				}
			});	
			myAlertDialog.show();
			break;
		}
		return true;
	}

	// Handles callbacks from GPS service
	private class GPSListener implements LocationListener {

		public void onLocationChanged(Location location) {
		}

		public void onStatusChanged(String s, int i, Bundle b) {
		}

		public void onProviderDisabled(String s) {
			//toastText("GPS turned off - Please turn ON");
			GPSisON = false;
		}

		public void onProviderEnabled(String s) {
			//toastText("GPS turned ON");
			GPSisON = true;
		}
	}


	// Simple text transparent popups (Top of screen)
	public static void topToastText(String message) {
		try {
			myToast.setText(message);
			myToast.setGravity(Gravity.TOP, 0	, 100);
			myToast.show();
		} catch (Exception ex) {
			loggingclass.writelog("Toast Message error: " + ex.getMessage(),
					null, true);
			// System.out.println(ex.getMessage());
		}
	}



	// Simple text transparent popups TOWARDS MIDDLE OF SCREEN
	public static void middleToastText(String message) {
		try {
			myToast.setText(message);
			myToast.setGravity(Gravity.CENTER, 0	, 0);
			myToast.show();
		} catch (Exception ex) {
			loggingclass.writelog("Toast Message error: " + ex.getMessage(),
					null, true);
			// System.out.println(ex.getMessage());
		}
	}


	// Simple text transparent popups (Bottom of screen)
	public static void bottomToastText(String message) {
		try {
			myToast.setText(message);
			myToast.setGravity(Gravity.BOTTOM, 0, 100);
			myToast.show();
		} catch (Exception ex) {
			loggingclass.writelog("Toast Message error: " + ex.getMessage(),
					null, true);
			// System.out.println(ex.getMessage());
		}
	}



	public static void screenAnimation(ViewGroup panel, int screenAnimation) {

		AnimationSet set = new AnimationSet(true);

		Animation animation = new AlphaAnimation(0.0f, 1.0f);
		animation.setDuration(100);
		set.addAnimation(animation);

		switch(screenAnimation) {

		case NORMAL:
			return;
			//break;

		case RIGHT:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, -1.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;
		case LEFT:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, 1.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;

		case TOP:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, -1.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;

		case BOTTOM:
			animation = new TranslateAnimation(
					Animation.RELATIVE_TO_SELF, 0.0f, Animation.RELATIVE_TO_SELF, 0.0f,
					Animation.RELATIVE_TO_SELF, 1.0f, Animation.RELATIVE_TO_SELF, 0.0f
					);
			break;

		}

		animation.setDuration(200);
		set.addAnimation(animation);

		LayoutAnimationController controller = new LayoutAnimationController(set, 0.25f);
		if (panel != null) {
			panel.setLayoutAnimation(controller);
		}
	}


	
	// Display the Terminal layout and associate it's buttons
	private void displayTerminal(int screenMovement) {
		//If we elected to use GPS time, start GPS listening now
		if (config.getPreferenceB("USEGPSTIME", false)) {
			locationManager = (LocationManager) this
					.getSystemService(Context.LOCATION_SERVICE);
			locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,
					60000, // milisecs
					0, // meters
					locationListener);
		}
		// Change layout and remember which one we are on
		currentview = TERMVIEW;
		setContentView(R.layout.terminal);
		screenAnimation((ViewGroup) findViewById(R.id.termscreen), screenMovement);
		myTermTV = (TextView) findViewById(R.id.terminalview);
		myTermTV.setHorizontallyScrolling(false);
		myTermTV.setTextSize(16);
		myWindow = getWindow();
		AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
		// If blank (on start), display version
		if (TerminalBuffer.length() == 0 && !hasDisplayedWelcome) {
			TerminalBuffer = welcomeString;
		} else {
			if (TerminalBuffer.equals(welcomeString)) {
				TerminalBuffer = "";
			}
		}
		hasDisplayedWelcome = true;
		// Reset terminal display in case it was blanked out by a new oncreate call
		myTermTV.setText(TerminalBuffer);
		myTermSC = (ScrollView) findViewById(R.id.terminalscrollview);
		// update with whatever we have already accumulated then scroll
		AndFlmsg.mHandler.post(AndFlmsg.addtoterminal);
		//Advise which screen we are in
		topToastText("Terminal Screen");

		// JD Initialize the Send Text button (commands in connected mode)
		myButton = (Button) findViewById(R.id.button_sendtext);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				// Send a message using content of the edit text widget
				TextView view = (TextView) findViewById(R.id.edit_text_out);
				String intext = view.getText().toString();

				try {
					if (!Processor.ReceivingForm) {
						Processor.TX_Text += (intext + "\n");
						//						Processor.q.send_txrsid_command("ON");
						Modem.sendln("", "", intext + "\n");
					} else {
						bottomToastText("Not while in the middle of receiving a message");
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					System.out.println(ex.getMessage());
				}
			}
		});
	}


	private void fileNameDialog(String filePath, String templateFileName, String dataBuffer) {
		final String savedFilePath = filePath;
		final String savedDataBuffer = dataBuffer;
		
		AlertDialog.Builder myAlertBuilder = new AlertDialog.Builder(this);
		LayoutInflater myInflater = LayoutInflater.from(this);
		final View fileNameDialogView = myInflater.inflate(R.layout.filenamedialog, null);
		myAlertBuilder.setView(fileNameDialogView)
				.setCancelable(true).setNegativeButton(
				"Cancel", new DialogInterface.OnClickListener() {
					public void onClick(DialogInterface dialog, int id) {
						// Hide the keyboard since we handle it manually
						InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
						imm.hideSoftInputFromWindow(fileNameDialogView.getWindowToken(), 0);
						dialog.cancel();
					}
				})
				.setPositiveButton("Save", new DialogInterface.OnClickListener() {

					public void onClick(DialogInterface dialog, int id) {
						TextView view = (TextView) fileNameDialogView.findViewById(R.id.edit_text_input);
						String newFileName = view.getText().toString().trim();
						if (newFileName.length() == 0) {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(fileNameDialogView.getWindowToken(), 0);
							dialog.cancel();
							middleToastText("File Name can't be blank");
						} else {
							// Hide the keyboard since we handle it manually
							InputMethodManager imm = (InputMethodManager) getSystemService(Context.INPUT_METHOD_SERVICE);
							imm.hideSoftInputFromWindow(fileNameDialogView.getWindowToken(), 0);
							//Do something with the file name
							Message.saveMessageAsFile(savedFilePath, newFileName, savedDataBuffer);
					    	// close popup
					    	pw.dismiss();
						}
					}
				});

		AlertDialog myFileNameAlert = myAlertBuilder.create();
		EditText view = (EditText) fileNameDialogView.findViewById(R.id.edit_text_input);
		view.setText(templateFileName);
		myFileNameAlert.setTitle("Enter File Name");
		myFileNameAlert.show();

	}


	

	static final String jsSendNewFormDataInject = "\n" + 
//			"	   	<input type=\"button\" onclick=\"queueForTx()\" value=\"Submit, Queue &#10;for TX\" />\n" + 
			"		<input type=\"button\" onclick=\"saveToOutbox('New')\" value=\"Submit, Save &#10;in Outbox\" />\n" + 
			"		<input type=\"button\" onclick=\"saveToDrafts('New')\" value=\"Submit, Save &#10;in Drafts\" />\n" + 
			"	   	<input type=\"button\" onclick=\"saveAsTemplate('New')\" value=\"Submit, Save as &#10;Template\" />\n" + 
//			"		<input type=\"button\" onclick=\"discardInput('New')\" value=\"Discard\" />\n" +
			"		<script src=\"file:///android_asset/andflmsg.js\" type=\"text/javascript\"></script>\n";


	static final String jsSendDraftFormDataInject = "\n" + 
//			"	   	<input type=\"button\" onclick=\"queueForTx('Existing')\" value=\"Submit, Queue &#10;for TX\" />\n" + 
			"		<input type=\"button\" onclick=\"saveToOutbox('Existing')\" value=\"Submit, Save &#10;in Outbox\" />\n" + 
			"		<input type=\"button\" onclick=\"saveToDrafts('Existing')\" value=\"Submit, Save &#10;in Drafts\" />\n" + 
			"	   	<input type=\"button\" onclick=\"saveAsTemplate('Existing')\" value=\"Submit, Save as &#10;Template\" />\n" + 
//			"		<input type=\"button\" onclick=\"discardInput('Existing')\" value=\"Discard\" />\n" +
			"		<script src=\"file:///android_asset/andflmsg.js\" type=\"text/javascript\"></script>\n";


	static final String jsSetAllReadOnlyInject = "\n <script type=\"text/javascript\">\n" + 
			"window.onload=setAllReadOnly();\n" + 
			"</script>\n" + 
			"";
	
	//Must match the declaration in flmsg.h: 
	//enum hdr_reason {NEW = 1, CHANGED = 2, FROM = 3};
	public static final int header_reason_NEW = 1;
	public static final int header_reason_CHANGED = 2;
	public static final int header_reason_FROM = 3;
	
	
	//Allows Javascript to call Android methods for submitting form data, calculating transmit time, change modes etc...
	public class JavascriptAccess {
	    Context mContext;

	    /** Instantiate the interface and set the context */
	    JavascriptAccess(Context c) {
	    	mContext = c;
	    }

	    //Shows the dialog for selecting the ARL messages (with parameters if required)
	    public void arlmessagesdialog(String msgField) {
	    	showArlMsgsDialog(msgField);
	    }

	    
	    //Shows the dialog for selecting the ARL messages (with parameters if required)
	    public void arlhxcodesdialog(String msgField) {
	    	showArlHxDialog(msgField);
	    }
	    
	    
	    //Calls ARL radiogram formatting function
	    //Updates both the check field and the message itself once formatted
	    public void arlmsgcheck(String msgFieldName, String msgFieldContent, String checkFieldName, String stdFormatStr) {
			boolean stdFormat = stdFormatStr.toUpperCase(Locale.US).equals("ON");
	    	checkField = Message.cbrgcheck(msgFieldContent, stdFormat);
	    	checkFieldToUpdate = checkFieldName;
	    	msgFieldToUpdate = msgFieldName;
			formattedMsg = Message.gettxtrgmsg();
	    	AndFlmsg.this.runOnUiThread(new Runnable() {
	    	     public void run() {
	    		    	mWebView.loadUrl("javascript:setField('" + checkFieldToUpdate + "','" + checkField + "')");
	    	    	 	mWebView.loadUrl("javascript:setField('" + msgFieldToUpdate + "','" + formattedMsg + "')");
	    	    }
	    	});
	    }
	    

	    
	    //Returns the current date as per the format preferences
	    public String dateprefill() {
	    	return Message.dateStamp();
	    }
	    
	    //Returns the current time as per the format preferences
	    public String timeprefill() {
	    	return Message.timeStamp();
	    }
	    
	    //Returns the current time as per the format preferences
	    public String datetimeprefill() {
	    	String ms = Message.dateTimeStamp();
	    	return ms;
	    }
	    
	    //Processes the received data from the form. 
	    // The string format received is the same as the content of the :mg: field of the custom forms
	    public void submitFormData(String formData, String jsAction, String jsNewDoc) {
	    	String dataBuffer;
	    	String customField;
	    	String extension;
	    	String fileName;
	    	
	    	//Update the JNI Env stored for retrieving preferences in Java
	    	Message.saveEnv();
			//debug: Processor.PostToTerminal("\nReceived Data from Form: <" + formData + ">\n");
	    	//Save data as a message
	    	if (jsNewDoc.equalsIgnoreCase("New")) {
	    		fileName = Message.namedFile();
	    		extension = Message.getExtension(Message.formName, false);//Message extension
	    		if (!fileName.isEmpty()) {
	    			fileName += extension;
	    		} else
	    			fileName = "new-" + config.getPreferenceS("SERNBR", "1") + extension;
	    		//Remove spaces from file name
	    		fileName = fileName.replaceAll(" ", "_");
	    	} else {
	    		fileName = mFileName;	//Updated before we entered the web editing step
	    		//Just in case, remove spaces from file name
	    		fileName = fileName.replaceAll(" ", "_");
	    		extension = Message.getExtension(Message.formName, false);//Message extension
	    	}			
	    	if (Message.isCustomForm(extension)) {
	    		//Add the first line of the custom field (e.g. CUSTOM_FORM,ICS218.html)
				customField = "CUSTOM_FORM," + Message.formName + "\n" + formData;
				//Build message buffer
				dataBuffer = Message.createCustomBuffer("", header_reason_NEW, customField);
			} else { //Hard-Coded forms. E.g. <radiogram>
				//Extract the form name as the character sequence before the first dot. 
				//Always in lower case
				String myHCForm = Message.formName.substring(0, Message.formName.indexOf(".")).toLowerCase(Locale.US);
				//Build message header first
				dataBuffer = Message.createHardCodedHeader("", header_reason_NEW, myHCForm);
				//Now build the message body from the form data, one field at a time
				Pattern psc = Pattern.compile("(^:.+:),\\\"((?:(?:.*[^\\\"]\\n)*)[^\\\"]*)\\\"|(^:.+:),(.*)", Pattern.MULTILINE);
				Matcher msc = psc.matcher(formData);
				boolean keepLooking = true;
				String element;
				String value;
				for (int start = 0; keepLooking;)
				{
					keepLooking = msc.find(start);
					if (keepLooking) {
						//String group0 = msc.group(0);
						String group1 = msc.group(1);
						String group2 = msc.group(2);
						String group3 = msc.group(3);
						String group4 = msc.group(4);
						if (group1 != null) {
							element = group1;
							value = group2;
						} else {
							element = group3;
							value = group4;
						}
						//Processor.PostToTerminal("\nField name <" + element + ">  ");
						//Processor.PostToTerminal("Field value <" + value + ">\n");
						dataBuffer += element + Integer.toString(value.length()) + " " + value + "\n";
						start = msc.end();
					}
				}
				//Now check for specific Hard Coded Forms processing BEFORE Storing the buffer in a file
				if (myHCForm.equals("radiogram")) { 
					//Reformat the :msg: field and Update the :ck: (check) field 
					String msgFieldContent = Message.getHcfFieldContent(dataBuffer, "msg");
					//Check if we have checked the "STD Format" button
					boolean stdFormat = (dataBuffer.indexOf(":std:2 ON") != -1);
					checkField = Message.cbrgcheck(msgFieldContent, stdFormat);
					//replace in buffer
					dataBuffer = Message.setHcfFieldContent(dataBuffer, "ck", checkField);
					formattedMsg = Message.gettxtrgmsg();
					//Remove escaped characters
					formattedMsg = Message.unescape(formattedMsg);
					dataBuffer = Message.setHcfFieldContent(dataBuffer, "msg", formattedMsg);
					//Reformat the two boolean fields
					if (dataBuffer.indexOf(":std:2 ON") != -1) dataBuffer = dataBuffer.replace(":std:2 ON", ":std:1 T");
					if (dataBuffer.indexOf(":std:3 OFF") != -1) dataBuffer = dataBuffer.replace(":std:3 OFF", ":std:1 F");
					if (dataBuffer.indexOf(":svc:2 ON") != -1) dataBuffer = dataBuffer.replace(":svc:2 ON", ":svc:1 T");
					if (dataBuffer.indexOf(":svc:3 OFF") != -1) dataBuffer = dataBuffer.replace(":svc:3 OFF", ":svc:1 F");
				}
			}
	    	//Then save the file
	    	String filePath = "";
			if (jsAction.equals("Queue")) {
				filePath = Processor.HomePath + Processor.Dirprefix
						+ Processor.DirOutbox + Processor.Separator;
				if (jsNewDoc.equals("New")) {
					Message.saveMessageAsFile(filePath, fileName, dataBuffer);
				} else {
					Message.deleteFile(Processor.DirDrafts, fileName, false);
					Message.saveDraftAsFile(filePath, fileName, dataBuffer);
				}
		    	// close popup
		    	pw.dismiss();
				//Android to-do: start TX of outbox in order of creation
			} else if (jsAction.equals("Discard")) {
		    	// close popup
		    	pw.dismiss(); 
			} else if (jsAction.equals("Templates")) {
				filePath = Processor.HomePath + Processor.Dirprefix
						+ Processor.DirTemplates + Processor.Separator;
				//Alert with new file name
				if (!jsNewDoc.equals("New")) {
					Message.deleteFile(Processor.DirDrafts, fileName, false);
				}
				fileNameDialog(filePath, fileName, dataBuffer);
			} else { //We have a simple directory path: use it (Outbox, Drafts etc..)
				filePath = Processor.HomePath + Processor.Dirprefix
						+ jsAction + Processor.Separator;
				if (jsNewDoc.equals("New")) {
					Message.saveMessageAsFile(filePath, fileName, dataBuffer);
				} else {
					Message.deleteFile(Processor.DirDrafts, fileName, false);
					Message.saveDraftAsFile(filePath, fileName, dataBuffer);
				}
				// close popup
		    	pw.dismiss();
			}
	    }
	    
	}
	
	

	class backgroundFormatForDisplay extends AsyncTask<Void, Integer, String>
	{
		String workingDir = "";
//		ProgressDialog progress;

		public backgroundFormatForDisplay(String mDir) {
			workingDir = mDir;
			//			progress = new ProgressDialog(AndFlmsg.myContext);
		}
		
		@Override
		protected void onPreExecute (){
			//progress.setTitle("Formatting...");
//			progress.setMessage("Wait while Formatting...");
//			progress.show();
	    }

		@Override
	    protected String doInBackground(Void...arg0) {

			mDisplayForm = Message.formatForDisplay(workingDir, mFileName, ".html");
	        return "";
	    }

	    protected void onProgressUpdate(Integer...a){
	    }

	    protected void onPostExecute(String result) {
//			progress.dismiss();
			mWebView.loadDataWithBaseURL("", mDisplayForm, "text/html", "UTF-8", ""); 
			//Debug
			// Processor.PostToTerminal("\nForm:\n" + myDisplayForm +"\n");
	    }
	}



	class backgroundNewFormDisplay extends AsyncTask<Void, Integer, String>
	{

//		ProgressDialog progress;

		public backgroundNewFormDisplay() {
//			progress = new ProgressDialog(AndFlmsg.myContext);
		}
		
		@Override
		protected void onPreExecute (){
			//progress.setTitle("Formatting...");
//			progress.setMessage("Wait while Formatting...");
//			progress.show();
		}

		@Override
	    protected String doInBackground(Void...arg0) {
			mDisplayForm = "";
			try
			{
				//Store the form name for later (when we post the form for example)
				Message.formName = mFileName;
				//Read the form into a string
				File f = new File(Processor.HomePath + Processor.Dirprefix
						+ Processor.DirEntryForms + Processor.Separator + mFileName);
				FileInputStream fileIS = new FileInputStream(f);
				BufferedReader buf = new BufferedReader(new InputStreamReader(fileIS));
				String readString = new String();
				while ((readString = buf.readLine()) != null)
				{
					mDisplayForm += readString + "\n";
				}
			}
			catch (FileNotFoundException e)
			{
				e.printStackTrace();
			}
			catch (IOException e)
			{
				e.printStackTrace();
			}
			//Inject the JavaScript into the form to get the data when the user selects the Submit button
			if (mDisplayForm.contains("</FORM>")) {
				mDisplayForm = mDisplayForm.replaceFirst("</FORM>","</FORM>" + jsSendNewFormDataInject);
			} else if (mDisplayForm.contains("</form>")) {
				mDisplayForm = mDisplayForm.replaceFirst("</form>","</form>" + jsSendNewFormDataInject);
			}
	        return "";
	    }

	    protected void onProgressUpdate(Integer...a){
	    }

	    protected void onPostExecute(String result) {
//			progress.dismiss();
			mWebView.loadDataWithBaseURL("", mDisplayForm, "text/html", "UTF-8", ""); 
	    }
	}


	
	class backgroundFormatForEditing extends AsyncTask<Void, Integer, String>
	{

		String workingDir = "";
		String injectJS = "";
//		ProgressDialog progress;

		public backgroundFormatForEditing(String mDir, String mInjectString) {
			workingDir = mDir;
			injectJS = mInjectString;
			//			progress = new ProgressDialog(AndFlmsg.myContext);
		}
		
		@Override
		protected void onPreExecute (){
			//progress.setTitle("Formatting...");
//			progress.setMessage("Wait while Formatting...");
//			progress.show();
	    }

		@Override
	    protected String doInBackground(Void...arg0) {
			//Format for display and sharing
			//mDisplayForm = Message.formatForEditing(Processor.DirDrafts, mFileName);
			mDisplayForm = Message.formatForEditing(workingDir, mFileName);
			//Inject the JavaScript into the form to get the data when the user selects the Submit button
			if (mDisplayForm.contains("</FORM>")) {
				mDisplayForm = mDisplayForm.replaceFirst("</FORM>","</FORM>" + injectJS);
			} else if (mDisplayForm.contains("</form>")) {
				mDisplayForm = mDisplayForm.replaceFirst("</form>","</form>" + injectJS);
			}
	        return "";
	    }

	    protected void onProgressUpdate(Integer...a){
	    }

	    protected void onPostExecute(String result) {
//			progress.dismiss();
			mWebView.loadDataWithBaseURL("", mDisplayForm, "text/html", "UTF-8", ""); 
			//Debug
			//Processor.PostToTerminal("\nForm:\n" + mDisplayForm +"\n");
	    }
	}

	
	
	//Popup Windows Dismiss listener
	OnDismissListener myDismissListerner = new OnDismissListener() {
		public void onDismiss() {
			runOnUiThread(new Runnable() {
				public void run() {
					//Re-display the lists in case we deleted or moved an item
					displayMessages(BOTTOM, currentview);
					//Update the title if we changed the mode (in Outbox view)
					AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
				}
			});
	    }
	};



	//Specific to ARL Radiogram: brings up the ARL pre-defined messages dialog
	private void showArlMsgsDialog(String msgField) {
		final String fieldToUpdate = msgField;
		AlertDialog.Builder myAlertDialogBuilder = new AlertDialog.Builder(AndFlmsg.this);
		LayoutInflater myLi = LayoutInflater.from(AndFlmsg.this);
		final View arlMsgsView = myLi.inflate(R.layout.arlmsgsdialog, null);
		myAlertDialogBuilder.setView(arlMsgsView);
		myAlertDialogBuilder.setMessage("Select an ARL message");
		myAlertDialogBuilder.setCancelable(false);
		myAlertDialogBuilder.setPositiveButton("Add Msg", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				//Extract the message from the returned value
				arlMsg = arlMsg.substring(0, arlMsg.indexOf(":"));
				EditText parameter1 = (EditText) myAlertDialog.findViewById(R.id.parameter1);
				EditText parameter2 = (EditText) myAlertDialog.findViewById(R.id.parameter2);
				EditText parameter3 = (EditText) myAlertDialog.findViewById(R.id.parameter3);
				EditText parameter4 = (EditText) myAlertDialog.findViewById(R.id.parameter4);
				//Enable the right number of parameter fields
				String arlMsgParameters = "";
				if (paramCount == 1) {
					arlMsgParameters = " " + parameter1.getText().toString();
				} else if (paramCount == 2) {
					arlMsgParameters = " " + parameter1.getText().toString() +
							" " + parameter2.getText().toString();
				} else if (paramCount == 3) {
					arlMsgParameters = " " + parameter1.getText().toString() +
							" " + parameter2.getText().toString() +
							" " + parameter3.getText().toString();
				} else if (paramCount == 4) {
					arlMsgParameters = " " + parameter1.getText().toString() +
							" " + parameter2.getText().toString() +
							" " + parameter3.getText().toString() +
							" " + parameter4.getText().toString();
				}
				if (paramCount > 0) {
					arlMsg += arlMsgParameters; 
				}
				//Call a Javascript on the webview to add to the arl text field
			    AndFlmsg.this.runOnUiThread(new Runnable() {
			        public void run() {
						mWebView.loadUrl("javascript:appendToField('" + fieldToUpdate + "',' ARL " + arlMsg + "')");
			        }
			    });
				dialog.cancel();
			}
		});
		myAlertDialogBuilder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				dialog.cancel();
				//Need to hide the keyboard?
			}
		});	
		
		myAlertDialog = myAlertDialogBuilder.create();
		myAlertDialog.show();
		//Populate the spinner list of messages
		Spinner spinner = (Spinner) myAlertDialog.findViewById(R.id.arlmsgsspinner);
		ArrayList<String> arlMsgsList = new ArrayList<String>();
		String[] arlArrayText = Message.getArlMsgTextList();
		for (int ii = 0; ii < arlArrayText.length; ii++) {
			if (!arlArrayText[ii].equals("")) {
				arlMsgsList.add(arlArrayText[ii]);
			}
		}

		ArrayAdapter<String> adp = 
				new ArrayAdapter<String> (AndFlmsg.this, R.layout.multilinespinnerdropdownitem, arlMsgsList);
		spinner.setAdapter(adp);
		spinner.setVisibility(View.VISIBLE);
		//Set listener Called when the item is selected in spinner
		spinner.setOnItemSelectedListener(new OnItemSelectedListener() 
		{
			public void onItemSelected(AdapterView<?> parent, View view,
					int position, long arg3) 
			{
				String thisArlMsg = parent.getItemAtPosition(position).toString();
				//Save value for "Add Msg" Button use
				arlMsg = thisArlMsg;
				//Count the number of parameters
				paramCount = 0;
				while (thisArlMsg.length() > 0 && thisArlMsg.contains("____")) {
					paramCount++;
					thisArlMsg = thisArlMsg.substring(thisArlMsg.indexOf("____") + 4);
				}
				EditText parameter1 = (EditText) myAlertDialog.findViewById(R.id.parameter1);
				EditText parameter2 = (EditText) myAlertDialog.findViewById(R.id.parameter2);
				EditText parameter3 = (EditText) myAlertDialog.findViewById(R.id.parameter3);
				EditText parameter4 = (EditText) myAlertDialog.findViewById(R.id.parameter4);
				//Enable the right number of parameter fields
				if (paramCount == 0) {
					parameter1.setEnabled(false);
					parameter2.setEnabled(false);
					parameter3.setEnabled(false);
					parameter4.setEnabled(false);
				} else if (paramCount == 1) {
					parameter1.setEnabled(true);
					parameter1.requestFocus();
					parameter2.setEnabled(false);
					parameter3.setEnabled(false);
					parameter4.setEnabled(false);
				} else if (paramCount == 2) {
					parameter1.setEnabled(true);
					parameter1.requestFocus();
					parameter2.setEnabled(true);
					parameter3.setEnabled(false);
					parameter4.setEnabled(false);
				} else if (paramCount == 3) {
					parameter1.setEnabled(true);
					parameter1.requestFocus();
					parameter2.setEnabled(true);
					parameter3.setEnabled(true);
					parameter4.setEnabled(false);
				} else if (paramCount == 4) {
					parameter1.setEnabled(true);
					parameter1.requestFocus();
					parameter2.setEnabled(true);
					parameter3.setEnabled(true);
					parameter4.setEnabled(true);
				}
			}
			
			public void onNothingSelected(AdapterView<?> arg0) 
			{
				// TODO Auto-generated method stub
			}
		});

	}	


	//Specific to ARL Radiogram: brings up the ARL delivery (HX) coded messages dialog
	private void showArlHxDialog(String hxField) {
		final String fieldToUpdate = hxField;
		AlertDialog.Builder myAlertDialogBuilder = new AlertDialog.Builder(AndFlmsg.this);
		LayoutInflater myLi = LayoutInflater.from(AndFlmsg.this);
		final View arlMsgsView = myLi.inflate(R.layout.arlhxdialog, null);
		myAlertDialogBuilder.setView(arlMsgsView);
		myAlertDialogBuilder.setMessage("Select ARL delivery codes");
		myAlertDialogBuilder.setCancelable(false);
		myAlertDialogBuilder.setPositiveButton("Add to HX Field", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				final EditText hxField = (EditText) myAlertDialog.findViewById(R.id.hxfield);
				//Call a Javascript on the webview to add to the arl text field
			    AndFlmsg.this.runOnUiThread(new Runnable() {
			        public void run() {
						mWebView.loadUrl("javascript:appendToField('" + fieldToUpdate + "','" + hxField.getText().toString() + "')");
			        }
			    });
				dialog.cancel();
			}
		});
		myAlertDialogBuilder.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int id) {
				dialog.cancel();
				//Need to hide the keyboard?
			}
		});
		
		myAlertDialog = myAlertDialogBuilder.create();
		myAlertDialog.show();
		//Populate the spinner list of messages
		Spinner spinner = (Spinner) myAlertDialog.findViewById(R.id.arlhxspinner);
		ArrayList<String> arlMsgsList = new ArrayList<String>();
		String[] arlArrayText = Message.getArlHxTextList();
		for (int ii = 0; ii < arlArrayText.length; ii++) {
			if (!arlArrayText[ii].equals("")) {
				arlMsgsList.add(arlArrayText[ii]);
			}
		}

		ArrayAdapter<String> adp = 
				new ArrayAdapter<String> (AndFlmsg.this, R.layout.multilinespinnerdropdownitem, arlMsgsList);
		spinner.setAdapter(adp);
		spinner.setVisibility(View.VISIBLE);
		//Set listener Called when the item is selected in spinner
		spinner.setOnItemSelectedListener(new OnItemSelectedListener() 
		{
			public void onItemSelected(AdapterView<?> parent, View view,
					int position, long arg3) 
			{
				String thisArlMsg = parent.getItemAtPosition(position).toString();
				//Save value for "Add Msg" Button use
				arlMsg = thisArlMsg.substring(0, thisArlMsg.indexOf(":"));
			}
			
			public void onNothingSelected(AdapterView<?> arg0) 
			{
				// TODO Auto-generated method stub
			}
		});
		// Add HX code to HX field button
		myButton = (Button) myAlertDialog.findViewById(R.id.button_addhxcode);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				//Format for display and sharing
				EditText hxField = (EditText) myAlertDialog.findViewById(R.id.hxfield);
				if (hxField.getText().toString() != "") {
					hxField.setText(hxField.getText().toString() + " " + arlMsg);
				}
			}
		});

	}	

	
	
	// Display one of the Messages layouts and associate it's buttons
	private void displayMessages(int screenAnimation, int msgScreen) {

		setContentView(R.layout.messages);
		screenAnimation((ViewGroup) findViewById(R.id.mailscreen), screenAnimation);

		// LayoutInflater for popup windows
		inflater = (LayoutInflater) this
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE);

		// Initialize the adapter for the exchange thread with server
		msgArrayAdapter = new ArrayAdapter<String>(this, R.layout.maillistview);
		msgListView = (ListView) findViewById(R.id.maillist);
		msgListView.setAdapter(msgArrayAdapter);
		msgListView.setDividerHeight(8);

		currentview = msgScreen;
		lastMsgScreen = currentview; // remember which email screen we were on

		switch (msgScreen) {
		case INBOXVIEW:
			//Disable the send all messages button
			myButton = (Button) findViewById(R.id.button_sendall);
			myButton.setEnabled(false);
			// Load Received Messages
			Message.loadFileListFromFolder(Processor.DirInbox);
			// Set listener for item selection
 			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
//			msgListView.setOnItemClickListener(new OnItemClickListener() {
//				public boolean onItemLongClick(AdapterView<?> parent,
				View view, final int position, long id) {
					// When LONG clicked, display the message
					try {
						View layout = inflater.inflate(R.layout.inboxmenupopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos 
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setOnDismissListener(myDismissListerner);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						inPopup = true;

						// View as HTML delivery button
						myButton = (Button) layout.findViewById(R.id.button_viewashtmldelivery);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//Format for display and sharing
								mDisplayForm = Message.formatForDisplay(Processor.DirInbox, mFileName, ".html");
								//Android Bug in Webview: Line Feeds are not rendered in loadData but are OK in loadDataWithBaseURL
								//mWebView.loadData(mDisplayForm, "text/html", "UTF-8"); 
								mWebView.loadDataWithBaseURL("", mDisplayForm, "text/html", "UTF-8", ""); 
								//Debug
								//Android Webview horizontal scroll issue
								mWebView.getSettings().setLoadWithOverviewMode(false);
								mWebView.getSettings().setUseWideViewPort(true);
							}
						});
						// View as HTML File Copy button
						myButton = (Button) layout.findViewById(R.id.button_viewashtmlfilecopy);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//Format for display and sharing
								mDisplayForm = Message.formatForDisplay(Processor.DirInbox, mFileName, ".fc.html");
								//Android Bug in Webview: Line Feeds are not rendered in loadData but are OK in loadDataWithBaseURL
								//mWebView.loadData(mDisplayForm, "text/html", "UTF-8"); 
								mWebView.loadDataWithBaseURL("", mDisplayForm, "text/html", "UTF-8", ""); 
								//Debug
								//Android Webview horizontal scroll issue
								mWebView.getSettings().setLoadWithOverviewMode(false);
								mWebView.getSettings().setUseWideViewPort(true);
							}
						});
						// View as Plain text button
						myButton = (Button) layout.findViewById(R.id.button_viewasplaintext);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//Format for display and sharing
								String textDisplayForm = Message.formatForDisplay(Processor.DirInbox, mFileName, ".txt");
								//For display in a webview, replace all Line Feeds with the "<br>" sequence
								textDisplayForm = textDisplayForm.replaceAll("\n", "<br>");
								mWebView.loadDataWithBaseURL("", textDisplayForm, "text/html", "UTF-8", ""); 
								//Debug
								//Android Webview horizontal scroll issue
								mWebView.getSettings().setLoadWithOverviewMode(false);
								mWebView.getSettings().setUseWideViewPort(true);
							}
						});
						// Share/Send button
						myButton = (Button) layout.findViewById(R.id.button_shareforward);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//Format for display and sharing
								mDisplayForm = Message.formatForDisplay(Processor.DirInbox, mFileName, ".html");
								Intent shareIntent = Message.shareInfoIntent(mDisplayForm, mFileName, ".html");
								startActivityForResult(Intent.createChooser(shareIntent, "Send Form..."), SHARE_MESSAGE_RESULT);
							}
						});
						//Copy to Drafts button
						myButton = (Button) layout.findViewById(R.id.button_cpdrafts);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								String newFileName = "Copy_of_" + mFileName;
								if (Message.copyAnyFile(Processor.DirInbox, mFileName, Processor.DirDrafts, newFileName) ) {
									AndFlmsg.middleToastText("Copied file: " + mFileName + " to Drafts Folder as " + newFileName + "\n");
								}
							}
						});
						//Copy to Drafts button
						myButton = (Button) layout.findViewById(R.id.button_cpoutbox);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								if (Message.copyAnyFile(Processor.DirInbox, mFileName, Processor.DirOutbox, mFileName) ) {
									AndFlmsg.middleToastText("Copied file: " + mFileName + " to Outbox Folder\n");
								}
							}
						});
						//Delete button
						myButton = (Button) layout.findViewById(R.id.button_delete);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
								myAlertDialog.setMessage("Are you sure you want to Delete This Message?");
								myAlertDialog.setCancelable(false);
								myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										Message.deleteFile(Processor.DirInbox, mFileName, true);//Advise deletion							
										inPopup = false;
										pw.dismiss(); // close popup
										displayMessages(BOTTOM, currentview);
									}
								});
								myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										dialog.cancel();
									}
								});	
								myAlertDialog.show();
							}
						});
						//Return button
						myButton = (Button) layout.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								inPopup = false;
								pw.dismiss(); // close popup
							}
						});
						mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			
						//Android Webview horizontal scroll issue
						mWebView.getSettings().setLoadWithOverviewMode(false);
						mWebView.getSettings().setUseWideViewPort(true);
						mFileName = (String) parent.getItemAtPosition(position);
						//Pre-load a "Formating..." Message
						mWebView.loadData("Formating...Please Wait", "text/html", "UTF-8"); 
						//Format for display and sharing
						new backgroundFormatForDisplay(Processor.DirInbox).execute();	
					}
					catch (Exception e)
					{
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required for web pages
			topToastText("Inbox View Screen \n\nLong Press on a Message for display");
			break;

			
		case FORMSVIEW:
			//Disable the send all messages button
			myButton = (Button) findViewById(R.id.button_sendall);
			myButton.setEnabled(false);
			// Load Html forms for edit of new messages
			Message.loadFileListFromFolder(Processor.DirEntryForms);
			// Set listener for item selection
			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					// When LONG clicked, display the file
					try {
						View layout = inflater.inflate(R.layout.formsmenupopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setOnDismissListener(myDismissListerner);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						inPopup = true;

						// Initialize the return button
						myButton = (Button) layout
								.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								inPopup = false;
								pw.dismiss(); // close popup
							}
						});
						// Initialize the transfer over the radio button
						myButton = (Button) layout
								.findViewById(R.id.button_transferoverradio);
						myButton.setEnabled(false);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//pw.dismiss(); // close popup
							}
						});
						// Initialize the Share over the Internet button
						myButton = (Button) layout
								.findViewById(R.id.button_shareoverinternet);
						myButton.setEnabled(false);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//pw.dismiss(); // close popup
							}
						});
						//Processor.PostToTerminal("\nForm: |" + mDisplayForm + "|\n");
						mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			
						//Android Debug thread exception
						Activity activityBaseContext = AndFlmsg.this;
						while(activityBaseContext.getParent() != null) {
						    Log.i("ActivityTree",activityBaseContext.getClass().getSimpleName());
						    activityBaseContext = activityBaseContext.getParent();
						}
						mWebView.getSettings().setJavaScriptEnabled(true);
						mWebView.setWebViewClient(new WebViewClient()); // wouldn't work without this!
						//Not needed yet (No Discard Button in form)
						//mWebView.setWebChromeClient(new WebChromeClient());
						mWebView.addJavascriptInterface(new JavascriptAccess(activityBaseContext), "JavascriptAccess");
						//Android horizontal scroll issue
						//mWebView.getSettings().setLoadWithOverviewMode(false);
						//mWebView.getSettings().setUseWideViewPort(true);
						//Pre-load a "Formating..." Message
						mWebView.loadData("Formating...Please Wait", "text/html", "UTF-8"); 
						//Format for display and sharing
						mFileName = (String) parent.getItemAtPosition(position);
						new backgroundNewFormDisplay().execute();	
					} catch (Exception e) {
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required
			topToastText("Forms View\n\n Long Press on a Form for creating a New Message");
			break;

		case DRAFTSVIEW:
			//Disable the send all messages button
			myButton = (Button) findViewById(R.id.button_sendall);
			myButton.setEnabled(false);
			// Load Draft Messages
			Message.loadFileListFromFolder(Processor.DirDrafts);
			// Set listener for item selection
 			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
//			msgListView.setOnItemClickListener(new OnItemClickListener() {
//				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					// When LONG clicked, display the message
					try {
						View layout = inflater.inflate(R.layout.draftsmenupopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos 
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setOnDismissListener(myDismissListerner);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						inPopup = true;

						//Delete button
						myButton = (Button) layout.findViewById(R.id.button_delete);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
								myAlertDialog.setMessage("Are you sure you want to Delete This Message?");
								myAlertDialog.setCancelable(false);
								myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										Message.deleteFile(Processor.DirDrafts, mFileName, true);//Advise deletion							
										inPopup = false;
										pw.dismiss(); // close popup
										displayMessages(BOTTOM, currentview);
									}
								});
								myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										dialog.cancel();
									}
								});	
								myAlertDialog.show();
							}
						});
						//Return button
						myButton = (Button) layout.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								inPopup = false;
								pw.dismiss(); // close popup
							}
						});
						mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			
						mWebView.getSettings().setJavaScriptEnabled(true);
						mWebView.setWebViewClient(new WebViewClient()); // wouldn't work without this!
						//mWebView.setWebChromeClient(new WebChromeClient());
						mWebView.addJavascriptInterface(new JavascriptAccess(AndFlmsg.myContext), "JavascriptAccess");
						//Android horizontal scroll issue
						mWebView.getSettings().setLoadWithOverviewMode(false);
						mWebView.getSettings().setUseWideViewPort(true);
						//Pre-load a "Formating..." Message
						mWebView.loadData("Formating...Please Wait", "text/html", "UTF-8"); 
						//Get the file name selected in the list
						mFileName = (String) parent.getItemAtPosition(position);
						new backgroundFormatForEditing(Processor.DirDrafts, jsSendDraftFormDataInject).execute();	
					}
					catch (Exception e)
					{
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required for web pages
			topToastText("Drafts View Screen \n\nLong Press on a file to Edit");
			break;
			

		case TEMPLATESVIEW:
			//Disable the send all messages button
			myButton = (Button) findViewById(R.id.button_sendall);
			myButton.setEnabled(false);
			// Load Template Messages
			Message.loadFileListFromFolder(Processor.DirTemplates);
			// Set listener for item selection
 			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
				View view, final int position, long id) {
					// When LONG clicked, display the message
					try {
						View layout = inflater.inflate(R.layout.draftsmenupopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos 
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setOnDismissListener(myDismissListerner);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						inPopup = true;
						
						//Delete button
						myButton = (Button) layout.findViewById(R.id.button_delete);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
								myAlertDialog.setMessage("Are you sure you want to Delete This Message?");
								myAlertDialog.setCancelable(false);
								myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										Message.deleteFile(Processor.DirTemplates, mFileName, true);//Advise deletion							
										inPopup = false;
										pw.dismiss(); // close popup
										displayMessages(BOTTOM, currentview);
									}
								});
								myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										dialog.cancel();
									}
								});	
								myAlertDialog.show();
							}
						});
						//Return button
						myButton = (Button) layout.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								inPopup = false;
								pw.dismiss(); // close popup
							}
						});
						mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			
						mWebView.getSettings().setJavaScriptEnabled(true);
						mWebView.setWebViewClient(new WebViewClient()); // wouldn't work without this!
						//mWebView.setWebChromeClient(new WebChromeClient());
						//Android horizontal scroll issue
						mWebView.getSettings().setLoadWithOverviewMode(false);
						mWebView.getSettings().setUseWideViewPort(true);
						mWebView.addJavascriptInterface(new JavascriptAccess(AndFlmsg.myContext), "JavascriptAccess");
						mWebView.loadData("Formating...Please Wait", "text/html", "UTF-8"); 
						//Get the file name selected in the list
						mFileName = (String) parent.getItemAtPosition(position);
						new backgroundFormatForEditing(Processor.DirTemplates, jsSendNewFormDataInject).execute();
					}
					catch (Exception e)
					{
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required for web pages
			topToastText("Templates View Screen \n\nLong Press on a Template to Create a New Message");
			break;
			
		case OUTBOXVIEW:
			//Enable the send all messages button
			myButton = (Button) findViewById(R.id.button_sendall);
			myButton.setEnabled(true);
			// Load list of messages in outbox
			Message.loadFileListFromFolder(Processor.DirOutbox);
			// Set listener for item selection
			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					// When LONG clicked, display the file
					try {
						final View outboxLayout = inflater.inflate(R.layout.outboxmenupopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(outboxLayout, winWidth, winHeight, true);
						pw.setOnDismissListener(myDismissListerner);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(outboxLayout, Gravity.TOP, 0, 0);
						inPopup = true;
						
						// Initialize the return button
						myButton = (Button) outboxLayout
								.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								inPopup = false;
								pw.dismiss(); // close popup
								//Update title in case we changed the mode
								AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
							}
						});
						// Initialize the transfer over the radio button
						myButton = (Button) outboxLayout
								.findViewById(R.id.button_sendoverradio);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								if (!Processor.TXActive && !AndFlmsg.SendingAllMessages) {
									inPopup = false;
									//prepare a runnable for updating the GUI list
									pw.dismiss(); // close popup
									displayMessagesRunnable = new DisplayMessagesRunner();
									Modem.sendln(Processor.DirOutbox, mFileName, "\n\n\n... start\n" + bufferToTx + "... end\n\n\n");
								} else {
									topToastText("Please Wait...Still Transmitting Messages");
								}
							}
						});
						// Initialize the Share over the Internet button
						myButton = (Button) outboxLayout
								.findViewById(R.id.button_shareoverinternet);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//Already done on entry: mDisplayForm = Message.formatForDisplay(Processor.DirInbox, mFileName, ".html");
								Intent shareIntent = Message.shareInfoIntent(mDisplayForm, mFileName, ".html");
								//Monitor is the "sharing" is done as we then move the file to the sent folder
								//startActivity(Intent.createChooser(share, "Send Form..."));
								startActivityForResult(Intent.createChooser(shareIntent, "Send Form..."), SHARE_MESSAGE_RESULT);
							}
						});
						//Delete button
						myButton = (Button) outboxLayout.findViewById(R.id.button_delete);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
								myAlertDialog.setMessage("Are you sure you want to Delete This Message?");
								myAlertDialog.setCancelable(false);
								myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										Message.deleteFile(Processor.DirOutbox, mFileName, true);//Advise deletion							
										inPopup = false;
										pw.dismiss(); // close popup
										displayMessages(BOTTOM, currentview);
									}
								});
								myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										dialog.cancel();
									}
								});	
								myAlertDialog.show();
							}
						});


						// JD Initialize the MODE UP button
						myButton = (Button) outboxLayout.findViewById(R.id.button_nextmode);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								try {
									if (!Processor.ReceivingForm && ProcessorON
											&& !Processor.TXActive && Modem.modemState == Modem.RXMODEMRUNNING) {
										Processor.TxModem = Processor.RxModem = Modem.getModeUpDown(Processor.RxModem, +1);
										Modem.changemode(Processor.RxModem); // to make the changes effective
										saveLastModeUsed(Processor.RxModem);
										//Update the time required to Tx
										String modeStr = Modem.modemCapListString[Modem.getModeIndexFullList(Processor.RxModem)];
										TextView myModeView = (TextView) outboxLayout.findViewById(R.id.modetext);
										myModeView.setText(modeStr);
										TextView estimateView = (TextView) outboxLayout.findViewById(R.id.estimatetext);
										String estimateStr = Message.estimate(modeStr, bufferToTx);
										estimateView.setText(estimateStr);
									}
								}
								// JD fix this catch action
								catch (Exception ex) {
									loggingclass.writelog(
											"Button Execution error: " + ex.getMessage(), null,
											true);
								}
							}
						});

						// JD Initialize the MODE DOWN button
						myButton = (Button) outboxLayout.findViewById(R.id.button_prevmode);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								try {
									if (!Processor.ReceivingForm && ProcessorON
											&& !Processor.TXActive && Modem.modemState == Modem.RXMODEMRUNNING) {
										Processor.TxModem = Processor.RxModem = Modem.getModeUpDown(Processor.RxModem, -1);
										Modem.changemode(Processor.RxModem); // to make the changes effective
										saveLastModeUsed(Processor.RxModem);
										//Update the time required to Tx
										String modeStr = Modem.modemCapListString[Modem.getModeIndexFullList(Processor.RxModem)];
										TextView myModeView = (TextView) outboxLayout.findViewById(R.id.modetext);
										myModeView.setText(modeStr);
										TextView estimateView = (TextView) outboxLayout.findViewById(R.id.estimatetext);
										String estimateStr = Message.estimate(modeStr, bufferToTx);
										estimateView.setText(estimateStr);
									}
								}
							// JD fix this catch action
							catch (Exception ex) {
								loggingclass.writelog(
										"Button Execution error: " + ex.getMessage(), null,
										true);
							}
						}
					});

						
						
						mWebView = (WebView) outboxLayout.findViewById(R.id.htmlwebview1);			
						//Android Webview horizontal scroll issue
						mWebView.getSettings().setLoadWithOverviewMode(false);
						mWebView.getSettings().setUseWideViewPort(true);
						mFileName = (String) parent.getItemAtPosition(position);
						//Pre-load a "Formating..." Message
						mWebView.loadData("Formating...Please Wait", "text/html", "UTF-8"); 
						//Format for display and sharing
						new backgroundFormatForDisplay(Processor.DirOutbox).execute();
						//Update mode and Tx time information
						bufferToTx = Message.formatForTx(Processor.DirOutbox, mFileName);
						String modeStr = Modem.modemCapListString[Modem.getModeIndexFullList(Processor.RxModem)];
						TextView myModeView = (TextView) outboxLayout.findViewById(R.id.modetext);
						myModeView.setText(modeStr);
						TextView estimateView = (TextView) outboxLayout.findViewById(R.id.estimatetext);
						String estimateStr = Message.estimate(modeStr, bufferToTx);
						estimateView.setText(estimateStr);

					} catch (Exception e) {
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required
			topToastText("Outbox View\n\n Long Press on a Message to select");
			break;

		case SENTITEMSVIEW:
			//Disable the send all messages button
			myButton = (Button) findViewById(R.id.button_sendall);
			myButton.setEnabled(false);
			// Load list of messages in Sent folder
			Message.loadFileListFromFolder(Processor.DirSent);
			// Set listener for item selection
			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					// When LONG clicked, display the file
					try {
						View layout = inflater.inflate(R.layout.sentitemsmenupopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setOnDismissListener(myDismissListerner);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						inPopup = true;

						// Initialize the return button
						myButton = (Button) layout
								.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								inPopup = false;
								pw.dismiss(); // close popup
							}
						});
						// Initialize the "Copy back to Outbox" button
						myButton = (Button) layout
								.findViewById(R.id.button_backtooutbox);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
						    	Message.copyAnyFile(Processor.DirSent, mFileName, Processor.DirOutbox, true);
						    	Message.deleteFile(Processor.DirSent, mFileName, false);//Don't advise deletion
								inPopup = false;
								pw.dismiss(); // close popup
								displayMessages(BOTTOM, currentview);
							}
						});
						// Initialize the Share over the Internet button
						myButton = (Button) layout
								.findViewById(R.id.button_shareoverinternet);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								//Already done on entry: mDisplayForm = Message.formatForDisplay(Processor.DirInbox, mFileName, ".html");
								Intent shareIntent = Message.shareInfoIntent(mDisplayForm, mFileName, ".html");
								//Monitor is the "sharing" is done as we then move the file to the sent folder
								//startActivity(Intent.createChooser(share, "Send Form..."));
								startActivityForResult(Intent.createChooser(shareIntent, "Send Form..."), SHARE_MESSAGE_RESULT);
							}
						});
						//Delete button
						myButton = (Button) layout.findViewById(R.id.button_delete);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
								myAlertDialog.setMessage("Are you sure you want to Delete This Message?");
								myAlertDialog.setCancelable(false);
								myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										Message.deleteFile(Processor.DirSent, mFileName, true);							
										inPopup = false;
										pw.dismiss(); // close popup
										displayMessages(BOTTOM, currentview);
									}
								});
								myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										dialog.cancel();
									}
								});
								myAlertDialog.show();
							}
						});
						mWebView = (WebView) layout.findViewById(R.id.htmlwebview1);			
						//Android Webview horizontal scroll issue
						mWebView.getSettings().setLoadWithOverviewMode(false);
						mWebView.getSettings().setUseWideViewPort(true);
						mFileName = (String) parent.getItemAtPosition(position);
						//Pre-load a "Formating..." Message
						mWebView.loadData("Formating...Please Wait", "text/html", "UTF-8"); 
						//Format for display and sharing
						new backgroundFormatForDisplay(Processor.DirSent).execute();	
					} catch (Exception e) {
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required
			topToastText("Sent Items View\n\nLong Press on a Message to View it");
			break;

			
		case LOGSVIEW:
			//Disable the send all messages button
			myButton = (Button) findViewById(R.id.button_sendall);
			myButton.setEnabled(false);
			// Load log text file
			Message.loadFileListFromFolder(Processor.DirLogs);
			// Set listener for item selection
			msgListView.setOnItemLongClickListener(new OnItemLongClickListener() {
				public boolean onItemLongClick(AdapterView<?> parent,
						View view, final int position, long id) {
					String mLogText = "";
					// When LONG clicked, display the file
					try {
						View layout = inflater.inflate(R.layout.logsmenupopup,
								(ViewGroup) findViewById(R.id.html_popup));
						Display display = ((WindowManager) getSystemService(WINDOW_SERVICE)).getDefaultDisplay();
						// Now we can retrieve all display-related infos
						int winWidth = display.getWidth();
						int winHeight = display.getHeight();
						// int orientation = display.getOrientation();
						// create a large PopupWindow (it will be clipped automatically if larger than main window)
						pw = new PopupWindow(layout, winWidth, winHeight, true);
						pw.setOnDismissListener(myDismissListerner);
						pw.setBackgroundDrawable(new BitmapDrawable()); // to
						// allow click event to be active, display the popup in the center
						pw.showAtLocation(layout, Gravity.TOP, 0, 0);
						inPopup = true;
						//TextView emailText = (TextView) layout.findViewById(R.id.emailtext);
						//String myDisplayForm = new String();
						mDisplayForm = "";
						try
						{
							String mFileName = (String) parent.getItemAtPosition(position);
							//Read the log file
							File f = new File(Processor.HomePath + Processor.Dirprefix
									+ Processor.DirLogs + Processor.Separator + mFileName);
							FileInputStream fileIS = new FileInputStream(f);
							BufferedReader buf = new BufferedReader(new InputStreamReader(fileIS));
							String readString = new String();
							while ((readString = buf.readLine()) != null)
							{
								mLogText += readString + "\n";
							}
						}
						catch (FileNotFoundException e)
						{
							e.printStackTrace();
						}
						catch (IOException e)
						{
							e.printStackTrace();
						}
						TextView logTextView = (TextView) layout.findViewById(R.id.logtext);
						logTextView.setText(mLogText);
						//Delete button
						myButton = (Button) layout.findViewById(R.id.button_delete);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								AlertDialog.Builder myAlertDialog = new AlertDialog.Builder(AndFlmsg.this);
								myAlertDialog.setMessage("Are you sure you want to Delete This Log File?");
								myAlertDialog.setCancelable(false);
								myAlertDialog.setPositiveButton("Yes", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										Message.deleteFile(Processor.DirLogs, Processor.messageLogFile, true);							
										inPopup = false;
										pw.dismiss(); // close popup
										displayMessages(BOTTOM, currentview);
									}
								});
								myAlertDialog.setNegativeButton("No", new DialogInterface.OnClickListener() {
									public void onClick(DialogInterface dialog, int id) {
										dialog.cancel();
									}
								});
								myAlertDialog.show();
							}
						});
						// Initialize the return button
						myButton = (Button) layout
								.findViewById(R.id.button_return);
						myButton.setOnClickListener(new OnClickListener() {
							public void onClick(View v) {
								inPopup = false;
								pw.dismiss(); // close popup
							}
						});
					} catch (Exception e) {
						e.printStackTrace();
					}
					return false;
				}
			});
			msgListView.performHapticFeedback(MODE_APPEND);
			// Advise user of long pressed required
			topToastText("Logs View\n\n Long Press on a Log file to view");
			break;


		default:
			break;

		}

		// Initialize the common buttons on the Message layout

		// Initialize the Inbox view button
		myButton = (Button) findViewById(R.id.button_inbox);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayMessages(BOTTOM, INBOXVIEW);
			}
		});

		// Initialize the Forms view button
		myButton = (Button) findViewById(R.id.button_forms);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayMessages(BOTTOM, FORMSVIEW);
			}
		});

		// Initialize the Template view button
		myButton = (Button) findViewById(R.id.button_templates);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayMessages(BOTTOM, TEMPLATESVIEW);
			}
		});


		// Initialize the Drafts view button
		myButton = (Button) findViewById(R.id.button_drafts);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayMessages(BOTTOM, DRAFTSVIEW);
			}
		});

		// Initialize the Outbox view button
		myButton = (Button) findViewById(R.id.button_outbox);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayMessages(BOTTOM, OUTBOXVIEW);
			}
		});

		// Initialize the Forms view button
		myButton = (Button) findViewById(R.id.button_sentitems);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayMessages(BOTTOM, SENTITEMSVIEW);
			}
		});

		// Initialize the Template view button
		myButton = (Button) findViewById(R.id.button_logs);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayMessages(BOTTOM, LOGSVIEW);
			}
		});

		// Initialize the send all messages button
		myButton = (Button) findViewById(R.id.button_sendall);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (!Processor.TXActive && !AndFlmsg.SendingAllMessages) {
					new backgroundSendAllMessages().execute();	
				} else {
					topToastText("Please Wait...Still Transmitting Messages");
				}
			}
		});

	} 


	class backgroundSendAllMessages extends AsyncTask<Void, Integer, String>
	{

		public backgroundSendAllMessages() {
		}
		
		@Override
		protected void onPreExecute (){
			SendingAllMessages = true;
	    }

		@Override
	    protected String doInBackground(Void...arg0) {
			//Send sequentially all messages in the outbox
			String[] msgToSend = Message.createFileListFromFolder(Processor.DirOutbox);
			if (msgToSend != null) {
				for (int i = 0; i < msgToSend.length; i++) {
					if (!Modem.stopTX) {
						txMessageCount = ": " + Integer.toString(i + 1) + "/" + Integer.toString(msgToSend.length);
						String bufferToTx = Message.formatForTx(Processor.DirOutbox, msgToSend[i]);
						displayMessagesRunnable = new DisplayMessagesRunner();
						Modem.sendln(Processor.DirOutbox, msgToSend[i], "\n\n\n... start\n" + bufferToTx + "... end\n\n\n");
						//Wait until the end of Transmission to queue the next file
						try {
							Thread.sleep(250);
						} catch (InterruptedException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}
						while (Processor.TXActive && !Modem.stopTX) {
							try {
								Thread.sleep(1000);
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						}
					}
				}
			}
	        return "";
	    }

	    protected void onProgressUpdate(Integer...a){
	    }

	    protected void onPostExecute(String result) {
	    	SendingAllMessages = false;
	    	txMessageCount = "";
			AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
	    }
	}

	

	public static void saveLastModeUsed(int modemCode) {
		SharedPreferences.Editor editor = AndFlmsg.mysp
				.edit();
		editor.putString("LASTMODEUSED",
				Integer.toString(modemCode));
		// Commit the edits!
		editor.commit();

	}

	
	
	// Display the Modem layout and associate it's buttons
	private void displayModem(int screenAnimation, boolean withWaterfall) {

		if (withWaterfall) {
			currentview = MODEMVIEWwithWF;
			setContentView(R.layout.modemwithwf);
			screenAnimation((ViewGroup) findViewById(R.id.modemwwfscreen), screenAnimation);
			// Get the waterfall view object for the runnable
			myWFView = (waterfallView) findViewById(R.id.WFbox);
		} else {
			currentview = MODEMVIEWnoWF;
			setContentView(R.layout.modemwithoutwf);
			screenAnimation((ViewGroup) findViewById(R.id.modemnwfscreen), screenAnimation);
			myWFView = null;
		}

		myModemTV = (TextView) findViewById(R.id.modemview);
		myModemTV.setHorizontallyScrolling(false);
		myModemTV.setTextSize(16);
		if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11) {
			myModemTV.setTextIsSelectable(false);
		}

		// initialise CPU load bar display
		CpuLoad = (ProgressBar) findViewById(R.id.cpu_load);

		// initialise squelch and signal quality dislay
		SignalQuality = (ProgressBar) findViewById(R.id.signal_quality);

		// Reset modem display in case it was blanked out by a new oncreate call
		myModemTV.setText(ModemBuffer);
		myModemSC = (ScrollView) findViewById(R.id.modemscrollview);
		// update with whatever we have already accumulated then scroll
		AndFlmsg.mHandler.post(AndFlmsg.addtomodem);

		// Advise user of which screen we are in
		topToastText("Modem Screen");

		if (withWaterfall) { // initialise two extra buttons

			// JD Initialize the Waterfall Sensitivity UP button
			myButton = (Button) findViewById(R.id.button_wfsensup);
			myButton.setOnClickListener(new OnClickListener() {
				public void onClick(View v) {
					try {
						if (myWFView != null) {
							myWFView.maxvalue /= 1.25;
							if (myWFView.maxvalue < 1)
								myWFView.maxvalue = 1.0;
							// store value into preferences
							SharedPreferences.Editor editor = AndFlmsg.mysp
									.edit();
							editor.putFloat("WFMAXVALUE",
									(float) myWFView.maxvalue);
							// Commit the edits!
							editor.commit();
						}
					}
					// JD fix this catch action
					catch (Exception ex) {
						loggingclass.writelog(
								"Button Execution error: " + ex.getMessage(),
								null, true);
					}
				}
			});

			// JD Initialize the Waterfall Sensitivity DOWN button
			myButton = (Button) findViewById(R.id.button_wfsensdown);
			myButton.setOnClickListener(new OnClickListener() {
				public void onClick(View v) {
					try {
						if (myWFView != null) {
							myWFView.maxvalue *= 1.25;
							if (myWFView.maxvalue > 40)
								myWFView.maxvalue = 40.0;
							// store value into preferences
							SharedPreferences.Editor editor = AndFlmsg.mysp.edit();
							editor.putFloat("WFMAXVALUE", (float) myWFView.maxvalue);
							// Commit the edits!
							editor.commit();
						}
					}
					// JD fix this catch action
					catch (Exception ex) {
						loggingclass.writelog(
								"Button Execution error: " + ex.getMessage(),
								null, true);
					}
				}
			});

		}

		// Initialize the RxRSID check box
		checkbox = (CheckBox) findViewById(R.id.rxrsid);
		Modem.rxRsidOn = config.getPreferenceB("RXRSID", false);
		checkbox.setChecked(Modem.rxRsidOn);
		checkbox.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (((CheckBox) v).isChecked()) {
					//Store preference
					config.setPreferenceB("RXRSID", true);
					Modem.rxRsidOn = true;
				} else {
					//Store preference
					config.setPreferenceB("RXRSID", false);
					Modem.rxRsidOn = false;
				}
			}
		});


		// Initialize the TxRSID check box
		checkbox = (CheckBox) findViewById(R.id.txrsid);
		Modem.txRsidOn = config.getPreferenceB("TXRSID", false);
		checkbox.setChecked(Modem.txRsidOn);
		checkbox.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				if (((CheckBox) v).isChecked()) {
					//Store preference
					config.setPreferenceB("TXRSID", true);
					Modem.txRsidOn = true;
				} else {
					//Store preference
					config.setPreferenceB("TXRSID", false);
					Modem.txRsidOn = false;
				}
			}
		});

		// JD Initialize the MODEM RX ON/OFF button
		myButton = (Button) findViewById(R.id.button_modemONOFF);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (ProcessorON) {
						if (Modem.modemState == Modem.RXMODEMRUNNING && 
								!Processor.ReceivingForm && !Processor.TXActive) {
							modemPaused = true;
							Modem.stopRxModem();	
							stopService(new Intent(AndFlmsg.this, Processor.class));
							//Force garbage collection to prevent Out Of Memory errors on small RAM devices
							System.gc();
						}
						//Only for Android 3.0 and UP
						if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
							//Remove the notification
							myNotificationManager.cancel(9999);
						}
						ProcessorON = false;
						//Set modem text as selectable
						TextView myTempModemTV = (TextView) findViewById(R.id.modemview);
						if (myTempModemTV != null) {
							if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11) {
								myTempModemTV.setTextIsSelectable(true);
							}
						}
					} else {
						if (Modem.modemState == Modem.RXMODEMIDLE) {
							modemPaused = false;
							//Force garbage collection to prevent Out Of Memory errors on small RAM devices
							System.gc();
							startService(new Intent(AndFlmsg.this,
									Processor.class));
							//Only for Android 3.0 and UP
						}
						ProcessorON = true;
						//Set modem text as NOT selectable
						TextView myTempModemTV = (TextView) findViewById(R.id.modemview);
						if (myTempModemTV != null) {
							if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11) {
								myTempModemTV.setTextIsSelectable(false);
							}
						}
						if (Double.valueOf(android.os.Build.VERSION.SDK) >= 11.0) {
							//Issue the notification
							myNotificationManager.notify(9999, myNotification);
						}
					}
					AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the MODE UP button
		myButton = (Button) findViewById(R.id.button_modeUP);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (!Processor.ReceivingForm && ProcessorON
							&& !Processor.TXActive && Modem.modemState == Modem.RXMODEMRUNNING) {
						Processor.TxModem = Processor.RxModem = Modem.getModeUpDown(Processor.RxModem, +1);
						Modem.changemode(Processor.RxModem); // to make the changes effective
						saveLastModeUsed(Processor.RxModem);
						AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the MODE DOWN button
		myButton = (Button) findViewById(R.id.button_modeDOWN);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (!Processor.ReceivingForm && ProcessorON
							&& !Processor.TXActive && Modem.modemState == Modem.RXMODEMRUNNING) {
						Processor.TxModem = Processor.RxModem = Modem.getModeUpDown(Processor.RxModem, -1);
						Modem.changemode(Processor.RxModem); // to make the changes effective
						saveLastModeUsed(Processor.RxModem);
						AndFlmsg.mHandler.post(AndFlmsg.updatetitle);
					}
				}
			// JD fix this catch action
			catch (Exception ex) {
				loggingclass.writelog(
						"Button Execution error: " + ex.getMessage(), null,
						true);
			}
		}
	});

		// JD Initialize the Squelch UP button
		myButton = (Button) findViewById(R.id.button_squelchUP);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					Modem.AddtoSquelch(5.0);
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the Squelch DOWN button
		myButton = (Button) findViewById(R.id.button_squelchDOWN);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					Modem.AddtoSquelch(-5.0);
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the TUNE button
		myButton = (Button) findViewById(R.id.button_tune);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {

					if (!Processor.TXActive && !Processor.ReceivingForm &&
							Modem.modemState == Modem.RXMODEMRUNNING) {
						Modem.TxTune();
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the WATERFALL ON/OFF button
		myButton = (Button) findViewById(R.id.button_waterfallONOFF);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (currentview == MODEMVIEWnoWF) {
						displayModem(NORMAL,true);
					} else {
						displayModem(NORMAL, false);
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

		// JD Initialize the STOP TX button
		myButton = (Button) findViewById(R.id.button_stopTX);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				try {
					if (Processor.TXActive) {
						Modem.stopTX = true;
					}
				}
				// JD fix this catch action
				catch (Exception ex) {
					loggingclass.writelog(
							"Button Execution error: " + ex.getMessage(), null,
							true);
				}
			}
		});

}



	// Display the About screen
	private void displayAbout() {
		currentview = ABOUTVIEW;

		// Open APRS layout by default until we have other activities defined
		setContentView(R.layout.about);
		TextView myversion = (TextView) findViewById(R.id.versiontextview);
		myversion.setText("          " + Processor.version);

		// JD Initialize the return to terminal button
		myButton = (Button) findViewById(R.id.button_returntoterminal);
		myButton.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				displayTerminal(BOTTOM);
			}
		});

	}

	
} //end of AndFlmsg class
